<?php


function is_value( $var,$val,$mark = 'CHECKED' ) {
   if( $var == $val )
      return "$mark value=\"$val\"";
   else
      return "value=\"$val\"";
}

function hiLine( $line,$interval = 2 ) {
   return !($line%$interval)?' class="odd" ':' class="even" ';
}

function size2human( $size ) {

   $size = (int) $size;

   $kb = 1024;         // Kilobyte
   $mb = 1024 * $kb;   // Megabyte
   $gb = 1024 * $mb;   // Gigabyte
   $tb = 1024 * $gb;   // Terabyte

   if($size < $kb) return $size."B";
   else if($size < $mb) return round($size/$kb,0)."KB";
   else if($size < $gb) return round($size/$mb,0)."MB";
   else if($size < $tb) return round($size/$gb,0)."GB";
   else return round($size/$tb,2)."TB";
}


function formicon( $file ) {

   if( (substr($file,-4) === 'jpeg') || (substr($file,-3) === 'gif') || (substr($file,-3) === 'jpg') )
      return '<img src="'.$file.'" alt="thumbnail" style="width: 48px; height: auto;" />';

   return '&nbsp;';
}


function htmlheader( $title = 'PHP Templates' ) {
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
   <title><?=$title?></title>
   <style type="text/css">
   	body { font-family: Verdana, sans-serif; color: #333; margin-left: 8%;}
   	h1, h2, h3 { margin: 10px 0px; font-family: Tahoma, sans-serif; }
   	h3 { margin: 20px 0px 10px 0px }
   	#demo { width: 650px; background-color: #eee; margin: 20px; padding: 10px; border: 1px dashed; }
   	#demo>h3 { margin: 0px 0px 10px 0px; }
   	address { font-size: 80%; }
   	a { color: #9b410e; }
   	table { font-size: 80%; margin: 10px; }
   	td { padding: 5px; }
   	.header { color: #fff; font-weight: bold; background-color: #69b; }
   	.odd { background-color: #fff; }
   	.even { background-color: #ceb; }
   	.edit { background-color: #f0c040; border: 1px solid; border-color: #fff #333 #333 #fff; margin: 20px; }
   	.edit td { vertical-align: top; }
   	.edit .label { font-weight: bold; font-size: 16px;  color: #fff; text-align: right; }
   	input { border: 1px solid;  }
   	li { padding: 15px; }
   </style>
</head>

<body>

<?php
}


